// Header file for random lookup tables
// Coded by Scott Evans 17/6/97
// Last Modified 17/6/97

#ifndef _RLOOKUP_H
#define _RLOOKUP_H

#include <timer.h>

// Offset into table, make this value random

_long RandOffset;

// Create a table containing random numbers (0-255)
//
// Parameters
//   size  - size of table
//
// Returns
//   Address of table or NULL if cannot allocate table

_byte *InitRandLookup(_word size)
{
     _word i=0;
     _byte *table=(_byte *)malloc(sizeof(_byte)*size);

     if(table)
          for(i=0;i<size;table[i++]=rand()%255);
     else
          return(0);

     return(table);
}

// Free memory used by a random lookup table

#define _KillRandLookup(table)     free(table)

// Get a random number from lookup table
// The bigger the table the longer the cycle

#define	_GetRand(table,size)   (table[TIMER+RandOffset%size])

#endif
